#include <sys/types.h>
#include <sys/stat.h>
#include <mem.h>
#include <string.h>
#include <dir.h>
#include <stdio.h>

#define TRUE 1
#define FALSE 0

#define FILESEP     '/'        /* tam da area para links */
#define TAM_LNK     100        /* tam da area para links */
#define TAM_RD      32768      /* tam dos buffers de I/O */
#define TAM_BLK     512        /* tam dos blocos de I/O */
#define TAM_PATH    200        /* tam max de nome de arquivo */
#define SIM         1          /* flag */
#define NAO         0          /* flag */
#define HEADER_VOL  '0'        /* id do header de volume */
#define HEADER_ARQ  '1'        /* id do header de arquivo */
#define BLK_DADO    '2'        /* id do bloco de dados */
#define TAIL_VOL    '3'        /* id do tail do volume */
#define FIM_VOL     '4'        /* id do fim de volume */
#define TAM_OVERH   4          /* n de bytes de overhead do bloco */
#define OFF_LRC     511        /* offset do lrc no bloco */
#define OFF_TAM     1          /* offset do tam do bloco de dados */
#define OFF_DADOS   3          /* offset do bloco de dados */

#define BITS 12
#define HASHING_SHIFT BITS-8
#define MAX_VALUE (1 << BITS) -1
#define MAX_CODE MAX_VALUE -1
#define TABLE_SIZE 5021
static int cmd = 1;
static int output_bit_count;
static unsigned long outputbit_buffer;
static unsigned char append_character [TABLE_SIZE];
static unsigned int p_code [TABLE_SIZE];
static int c_value [TABLE_SIZE];
static int inpubit_count=0;
static unsigned long input_bit_buffer=0L;
long tamen,tamsa;
unsigned char *bufsa;
static unsigned char decod_stack[4000];
static unsigned int next_code;
static unsigned int string_code;
static unsigned int index;
static unsigned int new_code;
static unsigned int old_code;
static unsigned int code;
static unsigned char *counter;
static unsigned char *string;
static unsigned char *buffer;
static int character;

char nome_disp [128],          /* nome do dispositivo/arq de saida */
     bufvol[20],               /* nome do volume */
     bufdata[30],              /* data de gravacao */
     *volume= bufvol,          /* pointer para nome do volume */
     *pbaux,                   /* pointer para buffer de I/O do dev */
     *pbdev,                   /* pointer para buffer de I/O do dev */
     *plrc,                    /* pointer para o lrc do bloco */
     *ptam,                    /* pointer para o tam do bloco */
     *bdev,                    /* end. inicial do buffer dev */
     *fimbdev,                 /* end. final do buffer dev */
     *sbrk (),                 /* declaracao explicita de sbrk */
     *pdata= bufdata;          /* pointer para dadta de gravacao */

int  op_l, op_m, op_s, op_r,   /* flags de opcoes do comando */
     op_c, op_k, op_v, op_e,
     op_b,
     fdisp,                    /* fd do arquivo de entrada/saida */
     nbdev,                    /* numero de buffers para I/O no dev */
     idxlnk = 0,               /* n. de links na tabela */
     nseqvol = 1;              /* n de sequencia do volume */
long nbgrav = 0L,              /* n de bytes gravados */
     data,                     /* data no formato interno */
     nbvol  = 0L,              /* tam do volume em bytes */
     kb_vol =0L;               /* tam do volume em kbytes */

long grava (),                 /* declaracoes explicitas */
     lwrite (),
     lread ();

#define BUFFER_LEITURA 800l
#define BYTES_LIDO_VEZ 200l /* Pelo menos 128 */

static char comprimido [BUFFER_LEITURA];
static long  nivel_buffer = 0, lidos;



struct entlnk {
                 char lnknome [TAM_PATH];
                 long lnkblk;
              }  tablnk[TAM_LNK];

   /* le */

  static int fim_arquivo = FALSE;


void limpa_memoria (void)
{
   cmd = 1;
   memset (append_character, 0, TABLE_SIZE);
   memset (p_code, 0, 2 * TABLE_SIZE);
   memset (c_value, 0,2 * TABLE_SIZE);
   memset (decod_stack, 0, 4000);
   output_bit_count = 0;
   outputbit_buffer = 0;
   inpubit_count=0;
   input_bit_buffer=0L;
   tamen = 0;
   tamsa = 0;
   next_code = 0;
   string_code = 0;
   index = 0;
   new_code = 0;
   old_code = 0;
   code = 0;
   character = 0;

   strcpy (nome_disp, "");
   strcpy (bufvol, "");
   strcpy (bufdata, "");

   op_l= op_m= op_s= op_r= op_c= op_k= op_v=
	 op_e= op_b= fdisp= nbdev= idxlnk = 0;
   nseqvol = 1;
   nbgrav = 0L;
   data = 0l;
   nbvol  = 0L;
   kb_vol =0L;

   fim_arquivo = FALSE;
   memset (comprimido, 0, BUFFER_LEITURA);
   nivel_buffer = 0l, lidos = 0l;

}

long le (entrada, buffer_leitura, tamanho)
FILE *entrada;
char *buffer_leitura;
long *tamanho;
{
char auxiliar [BUFFER_LEITURA];
char buffer_disco [BYTES_LIDO_VEZ];
long tam_buff = BUFFER_LEITURA;
long bniv_buf;


  if (nivel_buffer < *tamanho)
    if (!fim_arquivo) {
      do {
	lidos = fread (buffer_disco, 1, BYTES_LIDO_VEZ, entrada);
	if (lidos < BYTES_LIDO_VEZ)
	  fim_arquivo = TRUE;
	tam_buff = BUFFER_LEITURA;
	if (fim_arquivo && nivel_buffer < *tamanho)
	  if (cmd == 1)
	    cmd = 3;
	  else
	    cmd = 2; /* Fim da compressao */
	comprime (buffer_disco, &lidos, auxiliar, &tam_buff, cmd);
	if (cmd == 1)
	  cmd = 0; /* Continuacao da compressao */
	memncpy (comprimido, nivel_buffer, auxiliar, 0l, tam_buff);
	nivel_buffer += tam_buff;
	bniv_buf = nivel_buffer;
      } while (nivel_buffer < *tamanho && !fim_arquivo);
      if (nivel_buffer > *tamanho)
	copia (buffer_leitura, comprimido, *tamanho, &nivel_buffer);
      else
	copia (buffer_leitura, comprimido, nivel_buffer, &nivel_buffer);
      lidos = BUFFER_LEITURA;
      if (nivel_buffer == 0)
	if (fim_arquivo) {
	  *tamanho = bniv_buf;
	  return TRUE;
	}
      return FALSE;
    }
  else {
    *tamanho = nivel_buffer;
    copia (buffer_leitura, comprimido, nivel_buffer, &nivel_buffer);
    return TRUE;
  }
  else {
    copia (buffer_leitura, comprimido, *tamanho, &nivel_buffer);
    return FALSE;
 }
}

memncpy (saida, sain, entrada, entr, n)
char *saida, *entrada;
long n, sain, entr;
{
  int cont;

  for (cont = 0; cont < n; cont++)
    saida [sain + cont] = entrada [entr + cont];
}


copia (saida, entrada, tamanho, nivel)
char *saida, *entrada;
long tamanho, *nivel;
{
  int cont;

  memncpy (saida, 0l,  entrada, 0l, tamanho);
  *nivel -= tamanho;
  for (cont = 0; cont < *nivel; cont++)
    entrada [cont] = entrada [tamanho + cont];
}


grave (saida, buffer, tamanho)
FILE *saida;
char *buffer;
long tamanho;
{

#define BUFFER_SAIDA 1000l
  char bufsaida [BUFFER_SAIDA];
  long tam_saida = BUFFER_SAIDA;
  long taml;
  char *ptr;

  if (tamanho == 0)
    return;
  ptr = buffer;
  while (tamanho > 0) {
     taml = tamanho;
     expande (ptr, &taml, bufsaida, &tam_saida, BUFFER_SAIDA-600l, cmd);
     fwrite (bufsaida, 1, tam_saida, saida);
     if (taml != tamanho) {
	tamanho -= taml;
	cmd = 2;
	ptr += taml;
     }
     else {
       cmd = 0;
       break;
     }
  }
  cmd = 0;
}

/* C O M P R I M E */

comprime(bufent,tament,bufsai,tamsai,cmd)
unsigned char *bufent,*bufsai;
int cmd;
long *tament,*tamsai;
{
int i;
tamen=0L;
tamsa=0L;
bufsa=bufsai;
if (cmd==1 || cmd==3)
{
  next_code=256;
  for (i=0;i<TABLE_SIZE;i++)
   c_value[i] = -1;
  i=0;
  string_code = *bufent++ & 0377;
  ++tamen;
  output_bit_count=0;
  outputbit_buffer=0L;
}
while (++tamen <= *tament)
{
  character =  *bufent++ & 0377;
  index=find_match(string_code,character);
  if (c_value[index] != -1)
   {
     string_code=c_value[index];
   }
  else
   {
    if (next_code <=MAX_CODE)
      {
        c_value[index]=next_code++;
        p_code[index]=string_code;
        append_character[index]=character;
      }
    output_code(string_code);
    string_code=character;
   }
}
if (cmd==2 || cmd==3)
{
  output_code(string_code);
  output_code(MAX_VALUE);
  output_code(0);
}
*tamsai=tamsa;
return(0);
}

find_match(hash_prefix,hash_character)
int hash_prefix;
unsigned int hash_character;
{
int index;
int offset;

 index= (hash_character << HASHING_SHIFT) ^ hash_prefix;
 if (index==0)
     offset=1;
 else
     offset=TABLE_SIZE - index;
 while (1)
 {
  if (c_value[index] == -1)
      return (index);
  if (p_code[index] == hash_prefix && append_character[index] ==
     hash_character)
     return(index);
 index-= offset;
 if (index<0)
    index += TABLE_SIZE;
 }
}

/* Rotina usada pela compressao */

output_code (code)
unsigned int code;
{
unsigned int x;
  outputbit_buffer |= (unsigned long)code << (32-BITS-output_bit_count);
  output_bit_count += BITS;
  while (output_bit_count >= 8)
   {
     x = (unsigned int)(outputbit_buffer >> 24);
     *bufsa++ = x;
     tamsa+=1;
     outputbit_buffer <<= 8;
     output_bit_count -= 8;
   }
}


/* Rotina de expansao de buffers */



expande(bufent,tament,bufsai,tamsai, max, cmd)
unsigned char *bufent,*bufsai;
long *tament,*tamsai, max;
int cmd;
{
int y;
long tamen,tamsa;
unsigned int a;
tamen=tamsa=0L;


 if (cmd==1 || cmd==3)
{ 
   counter= decod_stack;
   inpubit_count=0;
   input_bit_buffer=0L;
   next_code=256;
   while (inpubit_count <= 24)
   {
      ++tamen;
      a= *bufent++ & 0377;
      input_bit_buffer |= ((unsigned long) a  <<
                     (24-inpubit_count));
      inpubit_count += 8;
   }
   old_code=input_bit_buffer >> (32-BITS);
   input_bit_buffer <<= BITS;
   inpubit_count -=BITS;

   character=old_code;
   *bufsai++=old_code;
   ++tamsa;
 }
   while    (tamen < *tament && tamsa < max)

{
   while (inpubit_count <=24)
   {
       ++tamen;
       if (tamen > *tament)
       {
          *tamsai=tamsa;
          return(0);
       }
       a= *bufent++ & 0377;
       input_bit_buffer |= ((unsigned long) a  <<
                     (24-inpubit_count));
       inpubit_count += 8;

   }
   new_code=input_bit_buffer >> (32-BITS) & 0177777;
   input_bit_buffer <<= BITS;
   inpubit_count -=BITS;
   if (new_code == (MAX_VALUE))
      break; 

   if (new_code>=next_code)
     {
       *counter=character;
       buffer=counter+1;
       code=old_code;
         y=0;
         while (code>255)
          {
           *buffer++ =append_character[code];
           code=p_code[code];
           if (y++>=4000)
            {
           fprintf(stderr,"erro fatal na expansao -1");
            exit();
            }
          }
          *buffer=code;
          string=buffer;
     }
   else
     {
       *counter=character;
       buffer=counter;
       code=new_code;
         y=0;
         while (code>255)
          {
           *buffer++ =append_character[code];
           code=p_code[code];
           if (y++>=4000)
            {
           fprintf(stderr,"erro fatal na expansao -2");
            exit();
            }
          }
          *buffer=code;
          string=buffer;
     }
   character= *string;
   while (string >= counter)
    {
        *bufsai = *string;
        ++bufsai;
        --string;
        ++tamsa;
    }
   if (next_code<=MAX_CODE)
     {
      p_code[next_code]=old_code & 0177777;
      append_character[next_code]=character & 0377;
      next_code++;
     }
    old_code=new_code;
}
*tamsai=tamsa;
*tament=tamen;
}
