/* ------------ modem.c --------- */

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include "serial.h"
#include "modem.h"
#include "timer.h"

char DIAL[] = "ATDP";

/* ----------- send a string to the modem ------------ */
void modem_out(char *s)
{
  while(*s) {
    if (*s == '~')
      sleep(1);
    else
      if (!write_serial(*s))
	break;
    s++;
  }
}


/* -------- release the modem --------- */
void release_modem(void)
{
  modem_out(RESET_MODEM);
  restore_timer();
  init_serial_port(2400l, 0, 1, 8);
  restore_serial_int();
  clear_serial_queue();
}

/* ----------- place a call -------------- */
int call_remote(char *phoneno)
{
  modem_out(DIAL);
  modem_out(phoneno);
  modem_out("\r");
  clear_serial_queue();
  /* possible verification returning success or failure */
  return (SUCCESS);
}

/* ------------- answer a call ------------ */
void answer_modem(void)
{
  modem_out(ANSWER);
  clear_serial_queue();
}

/* ------------ hang up the call ----------------- */
void hang_up(void)
{
  modem_out(HANG_UP);
  clear_serial_queue();
}
