/* TerNix.c - Emulador de Terminais Padrao VT100 */

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include "serial.h"
#include "modem.h"
#include "ternix.h"
#include "janela.h"
#include "input.h"

extern int SERIAL_PORT,  /* serial.h */
	   TX_DATA;      /* serial.h */

janela jan=NULL; /* Ponteiro para a pilha de janelas no heap */

int attrib=7,    /* Attributo corrente */
    sair=0;      /* Indica quando do camando de saida */

/* Rotina para substituir o tratamento do Control-Break e Control-C */

void interrupt far newbreakvet ()
{
  outp (TX_DATA, 3); /* Manda break pela linha */
}

void main (void)
{
  int conexao;
  long bound_rate;
  int parity, stopbits, wordlen;
  char telefone [30];

  void interrupt far (*oldbreakvet) ();
  void interrupt far (*olddosvet) ();

  oldbreakvet = getvect (0x1b);
  olddosvet = getvect (0x23);
  setvect (0x1b, newbreakvet); /* Rotina do Control-Break */
  setvect (0x23, newbreakvet); /* Rotina do Break do Dos. */

  nixtron (); /* janela da empresa */

  jan=salve_janela (10, 7, 70, 19, jan);
  moldura (10, 7, 70, 19, jan, 1, BLUE, WHITE);
  gotoxy (17, 2);
  cprintf ("Emulador de terminal VT100\n\n\r");
  intercept_timer (NULL);
  get_serial_informations (&bound_rate, &parity, &stopbits,
			   &wordlen, telefone);
  cprintf ("     Velocidade....: %lu\n\r", bound_rate);
  cprintf ("     Paridade......: ");
  switch (parity) {
    case 0:
      cprintf ("None\n\r");
      break;
    case 1:
      cprintf ("Odd\n\r");
      break;
    case 2:
      cprintf ("Even\n\r");
      break;
  }
  cprintf ("     Bits de Parada: %d\n\r", stopbits);
  cprintf ("     Tam. Palavra..: %d\n\r", wordlen);
  cprintf ("     Porta Serial..: %d\n\r", SERIAL_PORT);

  init_serial_port (bound_rate, parity, stopbits, wordlen);
  modem_out (RESET_MODEM);
  modem_out (INIT_MODEM);
  clear_serial_queue ();

  conexao=deal_fone_number (telefone);

  if (conexao==SUCCESS)
    emulate ();
  else {
    cprintf ("    SEM RESPOSTA Tecle algo.");
    getch ();
  }

  release_modem ();

  jan=feche_janela (feche_janela (jan));

  setvect (0x1b, oldbreakvet); /* Restaura os vetores de interrupcoes */
  setvect (0x23, olddosvet);
}

/* Produz a janela de identificacao do fabricante */

void nixtron (void)
{
  jan=salve_janela (1, 1, 80, 5, jan);
  moldura (1, 1, 80, 5, jan, 7, WHITE, BLACK);
  gotoxy (14, 2);
  cprintf ("Nixtron Comrcio e Desenvolvimento de Sistemas Ltda");
}

/* Recebe as informacoes das setagens e executa manutencao no arquivo de
   configuracao */

get_serial_informations (long *bound_rate, int *parity,
			 int *stopbits, int *wordlen, char *telefone)
{

  /* variaveis de interface */

  char input_descr [26];
  long input_rate;
  int input_parity;
  int input_stopbits;
  int input_wordlen;
  int input_serial;
  char input_telefone [30];
  char input_aux [50];

  /* Retencao das informacoes do arquivo de configuracao */

  char descr [10] [30];
  char tel [10] [30];
  long rate [10];
  int bit_parity [10];
  int bitstop [10];
  int word [10];
  int port_serial [10];

  FILE *config;
  int cont, contaux, opcao, escolha;

  if ((config=fopen (CONFIGURACAO, "r+b"))==NULL) {
      config=fopen (CONFIGURACAO,"w+b");
      strcpy (input_descr, "Descricao_vaga.");
      input_rate = 2400;
      input_parity = 0;
      input_stopbits = 1;
      input_wordlen = 8;
      input_serial = 1;
      strcpy (input_telefone, "Sem_telefone.");
      opcao = 0;
      for (cont = 0; cont < 10; cont++) {
	fprintf (config, "%6li %1d %1d %1d %1d %25s %25s ",
	    input_rate, input_serial, input_parity,
	    input_stopbits, input_wordlen, input_telefone, input_descr);
	strcpy (descr [cont], input_descr);
	rate [cont] = input_rate;
	bit_parity [cont] = input_parity;
	bitstop [cont] = input_stopbits;
	word [cont] = input_wordlen;
	strcpy (tel [cont], input_telefone);
	port_serial [cont] = input_serial;
      }
      fprintf (config, "%1i ", opcao);
  }
  else {
    for (cont = 0; cont < 10; cont++) {
      opcao = fscanf (config, "%li%d%d%d%d%s%s",
	    &input_rate, &input_serial, &input_parity,
	    &input_stopbits, &input_wordlen, input_telefone, input_descr);
      strcpy (descr [cont], input_descr);
      rate [cont] = input_rate;
      bit_parity [cont] = input_parity;
      bitstop [cont] = input_stopbits;
      word [cont] = input_wordlen;
      port_serial [cont] = input_serial;
      strcpy (tel [cont], input_telefone);
    }
    fscanf (config, "%d", &opcao);

  }
  fclose (config);

  jan = salve_janela (12, 12, 68, 23, jan);
  moldura (12, 12, 68, 23, jan, 5, BROWN, WHITE);
  do {
    clrscr ();
    gotoxy (5, 2);
    cprintf ("Configurao atual: %s", descr [opcao]);
    gotoxy (15, 4);
    cprintf ("1 - Conexo.");
    gotoxy (15, 5);
    cprintf ("2 - Escolhe configurao.");
    gotoxy (15, 6);
    cprintf ("3 - Modifica Configurao.");
    gotoxy (15, 7);
    cprintf ("4 - Mostra Configuraes");
    gotoxy (15, 9);
    cprintf ("Opo: [ ]");
    gotoxy (23, 9);
    input_aux [0] = (char) 1;
    do
      in_char (input_aux, BROWN, WHITE);
    while (input_aux [2] != '1' &&
	   input_aux [2] != '2' &&
	   input_aux [2] != '3' &&
	   input_aux [2] != '4');
    escolha = atoi (input_aux + 2);
    if (escolha == 4) {
      char mostra_paridade [10];

      jan = salve_janela (1, 6, 80, 24, jan);
      moldura (1, 6, 80, 24, jan, 7, GREEN, WHITE);
      gotoxy (3, 2);
      cprintf ("");
      cprintf ("ͻ");
      gotoxy (3, 3);
      cprintf ("         Descrio          Veloc.  Parid. Stopbit.");
      cprintf (" Porta  Palavra ");
      gotoxy (3, 4);
      cprintf ("");
      cprintf ("͹");
      for (cont = 0; cont < 9; cont ++) {
	gotoxy (3, cont + 5);
	switch (bit_parity [cont]) {
	  case 0:
	    sprintf (mostra_paridade, "None");
	    break;
	  case 1:
	    sprintf (mostra_paridade, "Odd");
	    break;
	  case 2:
	    sprintf (mostra_paridade, "Even");
	    break;
	}
	cprintf (" %-25.25s  %6li  %-5.5s     %1d       %1d       %1d    ",
	  descr [cont], rate [cont], mostra_paridade,
	  bitstop [cont], port_serial [cont], word [cont]);
      }
      gotoxy (3, 14);
      cprintf ("");
      cprintf ("ͼ");
      gotoxy (3, 16);
      cprintf ("Pressione <Enter> para retornar.");
      getche ();
      jan = feche_janela (jan);
    }
    if (escolha == 2 || escolha == 3) {
      jan = salve_janela (1, 6, 35, 21, jan);
      moldura (1, 6, 35, 21, jan, 4, BLUE, WHITE);
      for (cont = 0; cont < 10; cont++) {
	gotoxy (3, cont + 2);
	cprintf ("%d - %s", cont, descr [cont]);
      }
      gotoxy (6, 13);
      cprintf ("Fornea o tem [ ]");
      gotoxy (22, 13);
      input_aux [0] = (char) 1;
      do
	in_char (input_aux, GREEN, WHITE);
      while (!isdigit (input_aux [2]));
      opcao = atoi (input_aux + 2);
      if (escolha == 3) {
	jan=salve_janela (2, 7, 33, 21, jan);
	moldura (2, 7, 33, 21, jan, 3, WHITE, GREEN);
	gotoxy (3, 1);
	cprintf ("  Configurao anterior\n\r\n\r");
	cprintf ("         Descrio\n\r-  %s\n\r\n\r", descr [opcao]);
	cprintf ("     Velocidade....: %lu\n\r", rate [opcao]);
	cprintf ("     Paridade......: ");
	switch (bit_parity [opcao]) {
	  case 0:
	    cprintf ("None\n\r");
	    break;
	  case 1:
	    cprintf ("Odd\n\r");
	    break;
	  case 2:
	    cprintf ("Even\n\r");
	    break;
	}
	cprintf ("     Bits de Parada: %d\n\r", bitstop [opcao]);
	cprintf ("     Tam. Palavra..: %d\n\r", word [opcao]);
	cprintf ("     Porta Serial..: %d\n\r", port_serial [opcao]);
	cprintf ("         Telefone\n\r- %s\n\r", tel [opcao]);
	jan=salve_janela (35, 6, 80, 22, jan);
	moldura (35, 6, 80, 22, jan, 7, GREEN, WHITE);
	gotoxy (2, 2);
	cprintf ("Velocidade de comunicao: ");
	input_aux [0] = (char) 6;
	do {
	  in_char (input_aux, GREEN, WHITE);
	  *bound_rate=atol (input_aux + 2);
	} while (*bound_rate !=    110l &&
		 *bound_rate !=    300l &&
		 *bound_rate !=    600l &&
		 *bound_rate !=   1200l &&
		 *bound_rate !=   2400l &&
		 *bound_rate !=   4800l &&
		 *bound_rate !=   9600l &&
		 *bound_rate !=  19200l &&
		 *bound_rate !=  38400l &&
		 *bound_rate !=  57600l &&
		 *bound_rate != 115200l);
	rate [opcao] = *bound_rate;
	gotoxy (2, 4);
	cprintf ("Bits de paridade (0=None, 1=Odd, 2=Even):");
	input_aux [0] = (char) 1;
	do {
	  in_char (input_aux , GREEN, WHITE);
	  *parity=input_aux [2]-48;
	} while (*parity != 0 && *parity != 1 && *parity != 2);
	bit_parity [opcao] = *parity;
	gotoxy (2, 6);
	cprintf ("Bits de parada (1 ou 2):");
	input_aux [0] = (char) 1;
	do {
	  in_char (input_aux, GREEN, WHITE);
	  *stopbits=input_aux [2]-48;
	} while (*stopbits != 1 && *stopbits != 2);
	bitstop [opcao] = *stopbits;
	gotoxy (2, 8);
	cprintf ("Tamanho da palavra (7 ou 8):");
	input_aux [0] = (char) 1;
	do {
	  in_char (input_aux, GREEN, WHITE);
	  *wordlen=atoi (input_aux +2);
	} while (*wordlen != 7 && *wordlen != 8);
	word [opcao] = *wordlen;
	gotoxy (2, 10);
	cprintf ("Porta de comunicao (1...4).:");
	input_aux [0] = (char) 1;
	do {
	  in_char (input_aux, GREEN, WHITE);
	  SERIAL_PORT=atoi (input_aux +2);
	} while (SERIAL_PORT < 1 || SERIAL_PORT > 4);
	port_serial [opcao] = SERIAL_PORT;
	gotoxy (2, 12);
	cprintf ("Telefone: ");
	input_aux [0] = (char) 25;
	in_char (input_aux, GREEN, WHITE);
	strcpy (input_telefone, input_aux + 2);
	if (!strcmp (input_telefone, "")) {
	  strcpy (input_telefone, "Sem_telefone");
	  cprintf ("Sem telefone.");
	}
	for (cont = 0; cont < strlen (input_telefone); cont++)
	  if (input_telefone [cont] == ' ')
	     input_telefone [cont] = '_';
	strcpy (tel [opcao], input_telefone);
	gotoxy (2, 14);
	cprintf ("Descrio: ");
	do {
	  input_aux [0] = (char) 25;
	  in_char (input_aux, GREEN, WHITE);
	} while (!strcmp (input_aux + 2, ""));
	strcpy (descr [opcao], input_aux + 2);
	for (cont = 0; cont < strlen (descr [opcao]); cont++)
	  if (descr [opcao] [cont] == ' ')
	     descr [opcao] [cont] = '_';
	jan = feche_janela (feche_janela (jan));

      }
      jan=feche_janela (jan);
      config=fopen (CONFIGURACAO,"w+b");
      for (cont = 0; cont < 10; cont++) {
	strcpy (input_descr, descr [cont]);
	input_rate = rate [cont] ;
	input_parity = bit_parity [cont] ;
	input_stopbits = bitstop [cont];
	input_wordlen = word [cont];
	input_serial = port_serial [cont];
	strcpy (input_telefone, tel [cont]);
	fprintf (config, "%6li %1d %1d %1d %1d %25s %25s ",
	      input_rate, input_serial, input_parity,
	      input_stopbits, input_wordlen, input_telefone, input_descr);
      }
      fprintf (config, "%1i ", opcao);
      fclose (config);
    }
    *bound_rate = rate [opcao];
    *parity = bit_parity [opcao];
    *stopbits = bitstop [opcao];
    *wordlen = word [opcao];
    SERIAL_PORT = port_serial [opcao];
    strcpy (telefone, tel [opcao]);
  } while (escolha != 1 && escolha != 2);
  jan=feche_janela (jan);
}

/* discagem do telefone se houver */

int deal_fone_number (char *telefone)
{
  char user_fone [50]="",
       soft_fone [50]="";
  int  user_posit,
       soft_posit=0;

  strcpy (user_fone, telefone);
  for (user_posit=0; user_posit < strlen (user_fone); user_posit++)
    if (isdigit (user_fone [user_posit]))
       soft_fone [soft_posit++]=user_fone [user_posit];
  soft_fone [soft_posit]= (char) 0;

  if (!strcmp (user_fone, ""))
    cprintf ("\n\r     Sem numero para discagem.");
  else {
    cprintf ("\n\r     Numero do telefone: %s", user_fone);
    call_remote (soft_fone);
  }
  return (SUCCESS);
 }

/* Send_Sequence - Filtra o teclado do usuario para o padrao VT100
   Recebe: O caracter teclado e o codito da varredura para a identificacao
   das teclas especiais como as de funcoes. */

void send_sequence (int character, int scan_code)
{
  char c, sequence [20];
  if (isalnum (character))
    write_serial (character);
  else {
    switch (scan_code) {
      case SETAESQUERDA:
	getch ();           /* Retira a segunda parte da tecla especial */
	write_serial (ESC);
	write_serial ('[');
	write_serial ('D');
	break;
      case SETADIREITA:
	getch ();
	write_serial (ESC);
	write_serial ('[');
	write_serial ('C');
	break;
      case SETACIMA:
	getch ();
	write_serial (ESC);
	write_serial ('[');
	write_serial ('A');
	break;
      case SETABAIXO:
	getch ();
	write_serial (ESC);
	write_serial ('[');
	write_serial ('B');
	break;
      case F1:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '1');
	modem_out (sequence);
	break;
      case F2:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '2');
	modem_out (sequence);
	break;
      case F3:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '3');
	modem_out (sequence);
	break;
      case F4:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '4');
	modem_out (sequence);
	break;
      case F5:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '5');
	modem_out (sequence);
	break;
      case F6:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '6');
	modem_out (sequence);
	break;
      case F7:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '7');
	modem_out (sequence);
	break;
      case F8:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '8');
	modem_out (sequence);
	break;
      case F9:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '9');
	modem_out (sequence);
	break;
      case F10:
	getch ();
	sprintf (sequence, "%c%c%c", ESC, '[', '0');
	modem_out (sequence);
	break;
      default:
	write_serial (character);
    }
  }
}

/* Receive_Sequence - Filtra os caracteres recebidos pela porta serial e
   executa os comandos reconhecidos de acordo com os padroes VT100. */

void receive_command (int charrec)
{
  int character;       /* Armazena o caracter recebido pela linha */
  char sequence [20];  /* Agrupamento da sequencia de controle */
  int posit=0,         /* Posicao de cada caracter de controle */
      cont;
  int res [2]={0, 0},  /* Armazena os parametros numericos caso existam */
      vez=0;           /* Indica se esta sendo reconhecido o primeiro parametro
			  numerio ou o segundo */
  int sair=0,          /* Indica que o reconhecimento chegou ao fim */
      erro=0;          /* Indica que a sequencia nao foi reconhecida,
			  devendo ser mostrada atraves da variavel de
			  armazenamento 'sequence' */

  if (charrec == ESC) {
    sequence [posit++]=ESC;
    do {
      while ((sequence [posit]=character=read_serial ()) == FALSE)
      ;
      posit++;
      if (isdigit (character)) {
	if (sequence [1] == '[')
	  if (res [vez] == 0)
	    res [vez]=valor(character);
	  else {
	    res [vez]*=10;
	    res [vez]+=valor(character);
	  }
	else {
	  if (character == '7')  /* 386 ESC 7 savorg savpos savbuf */
	    sair = 1;
	  else
	    if (character == '8')  /* 386 ESC 8 resorg respos resbuf */
	      sair = 1;
	    else
	      sair=erro=1;
	}
      }
      else
	switch (character) {
	  case '[': /* Ok, pode continuar */
	    break;
	  case ';': {
	    if (vez == 0) /* Deve-se reconhecer o segundo parametro numerico */
	      vez=1;
	    else
	      sair=erro=1;
	    break;
	  }
	  case 'H': /* Posicionamento do cursor */
	  case 'f': {
	    if (res [0] == 0)
	      res [0]=1;
	    if (res [1] == 0)
	      res [1]=1;
	    gotoxy (res [1], res [0]);
	    sair=1;
	    break;
	  }
	  case 'r': {  /* 386  - setar margem ???*/
	    sair = 1;
	    break;
	  }
	  case '?':
	    break;
	  case 'h':
	  case 'l': { /* 386 */
	    sair = 1;
	    break;
	  }
	  case '=': {
	    sair = 1; /* 386 set flag (a, 5) application mode */
	    break;
	  }
	  case '>': {
	    sair = 1; /* 386 set flan (a, 4) numeric mode */
	    break;
	  }
	  case 'm': { /* Mudanca de atributo de video */
	    switch (res [0]) {
	      case 0:
		attrib=7;
		sair=1;
		break;
	      case 1:
		attrib=14;
		sair=1;
		break;
	      case 4:
		attrib=1;
		sair=1;
		break;
	      case 5:
		attrib=128;
		sair=1;
		break;
	      case 7:
		attrib=112;
		sair=1;
		break;
	      default:
		sair=erro=1;
	    }
	    break;
	  }
	  case 'i': {
	      char entrada, codigo [5], tecla;
	      int ptr = 0;

	      if (res [0] == 5) {
		sprintf (codigo, "%c[4i", 27);
		jan = salve_janela (30, 5, 50, 8, jan);
		moldura (30, 5, 50, 7, jan, 5, WHITE, BLACK);
		cprintf ("    Imprimindo...");
		while (1) {
		  while ((entrada = read_serial ()) == FALSE &&
			 (tecla = bioskey (1)) == 0)
		  ;
		  if (tecla != 0)
		    break;
		  if (entrada == codigo [ptr]) {
		    if (ptr == 3) {
		      sair = 1;
		      break;
		    }
		    ptr++;
		    continue;
		  }
		  else
		    if (ptr != 0) {
		      int i;

		      for (i = 0; i < ptr; i++)
			putc (codigo [i], stdprn);
		      ptr = 0;
		      if (entrada == 27) {
			ptr = 1;
			continue;
		      }
		    }
		  putc (entrada, stdprn);
		}
		sair = 1;
	      }
	      else
		sair = erro = 1;
	    jan = feche_janela (jan);
	    break;
	  }
	  case 'J': {
	    if (sequence [1] == '[')
	      switch (res [0]) { /* Limpa do curso ate o fim da tela */
		case 0:
		case 1: {
		  int x, y, cont;

		  x=wherex ();
		  y=wherey ();
		  for (cont=y; cont<25; cont++) {
		    gotoxy (1, cont);
		    clreol ();
		  };
		  gotoxy (x, y);
		  sair=1;
		  break;
		}
		case 2: {  /* Limpa toda a tela */
		  clrscr_asm ();
		  gotoxy (1, 1);
		  sair=1;
		  break;
		}
		default:
		  sair=erro=1;
	      }
	    else
	      sair=erro=1;
	    break;
	  }
	  case 'K': {
	    if (sequence [1] == '[')
	      switch (res [0]) { /* Limpa ate o final da linha */
		case 0:
		case 1: {
		  int x, y, cont;

		  x=wherex ();
		  y=wherey ();
		  clreol ();
		  gotoxy (x, y);
		  sair=1;
		  break;
		}
		case 2: { /* Limpa toda a linha */
		  int x, y, cont;

		  x=wherex ();
		  y=wherey ();
		  gotoxy (1, y);
		  clreol ();
		  gotoxy (x, y);
		  sair=1;
		  break;
		}
		default:
		  sair=erro=1;
	      }
	    else
	      sair=erro=1;
	    break;
	  }
	  case 'A': { /* Cursor para cima */
	    int posicao;
	    if (res [0] == 0)
	      res [0] = 1;
	    posicao=(wherey ()-res [0]);
	    gotoxy (wherex (), posicao);
	    sair=1;
	    break;
	  }
	  case 'B': { /* Cursor para baixo */
	    int posicao;
	    if (res [0] == 0)
	      res [0] = 1;
	    posicao=(wherey ()+res [0]);
	    gotoxy (wherex (), posicao);
	    sair=1;
	    break;
	  }
	  case 'C': { /* Cursor para a direita */
	    int posicao;
	    if (res [0] == 0)
	      res [0] = 1;
	    posicao = wherex () + res [0];
	    gotoxy (posicao, wherey ());
	    sair=1;
	    break;
	  }
	  case 'D': { /* Cursor para a esquerda */
	    int posicao;
	    if (res [0] == 0)
	      res [0] = 1;
	    posicao = wherex () - res [0];
	    gotoxy (posicao, wherey ());
	    sair=1;
	    break;
	  }
	  case 'M': { /* Scroll da tela para baixo */
	    if (posit == 2) {
	      mova_baixo_asm (attrib);
	      sair=1;
	    }
	    else
	      sair=erro=1;
	    break;
	  }
	  case 'T': {
	    jan = salve_janela (25, 8, 75, 16, jan);
	    moldura (25, 8, 75, 16, jan, 3, GREEN, YELLOW);
	    limpa_memoria ();
	    receive_protocol_xmodem ();
	    cprintf ("\n  Pressione <Enter> para continuar...");
	    getch ();
	    jan = feche_janela (jan);
	    sair=1;
	    break;
	  }
	  case 'R': {
	    jan = salve_janela (25, 8, 75, 16, jan);
	    moldura (25, 8, 75, 16, jan, 3, GREEN, YELLOW);
	    limpa_memoria ();
	    send_protocol_xmodem ();
	    cprintf ("\n  Pressione <Enter> para continuar...");
	    getch ();
	    jan = feche_janela (jan);
	    sair=1;
	    break;
	  }
	  default:
	    sair=erro=1;
	}
    } while (sair==0);
  }
  else {
    switch (charrec) {
      case 7: /* Nao e permitido acionar o 'BEEP' */
	break;
      case 9: { /* Executar tabulacao */
	int x;

	x=wherex ();
	while (((x-1) % 8) != 0) {
	  putch (' ');
	  x=wherex ();
	}
	break;
      }
      case 12: { /* Limpar a tela */
	clrscr_asm ();
	break;
      }
      default:
	putch (charrec);
    }
  }
  if (erro==1) /* Sequencia de controle nao reconhecida */
    for (cont=0; cont<posit; putch (sequence [cont]), cont++);
}

/* Produz o rodape da tela de emulacao
   Obs: Escreve direto na memoria de video da placa */

void liga_rodape ()
{
  int cont, character, far *tela = MK_FP (0xB000, 0x8000);
  char empr [22] = "Nixtron Informtica.",
       emul [16] = "EMULADOR VT100",
       sair [12] = "Alt-X Sair";

  character = 0x2f00;
  for (cont=0; cont<80; cont++)
    tela [80*24+cont] = character + 0x20;
  for (cont=0; empr [cont] != 0; cont++)
    tela [80*24+3+cont] = character + empr [cont];
  for (cont=0; emul [cont] != 0; cont++)
    tela [80*24+36+cont] = character + emul [cont];
  for (cont=0; sair [cont] != 0; cont++)
    tela [80*24+65+cont] = character + sair [cont];
}

int pegach ()
{
  char far *ptini = MK_FP (0x0000, 0x041a);
  char far *ptfim = MK_FP (0x0000, 0x041c);
  char far *ptbuf = MK_FP (0x0000, 0x041e);

  if (ptfim [0] != 30) {
    ptini [0] = 30;
    ptini [1] = 0;
    ptfim [0] = 30;
    ptfim [1] = 0;
    return ((int) ptbuf [0]);
  }
  else
    return 0;
}

inic_pegach ()
{
  char far *ptini = MK_FP (0x0000, 0x041a);
  char far *ptfim = MK_FP (0x0000, 0x041c);

  ptini [0] = 30;
  ptini [1] = 0;
  ptfim [0] = 30;
  ptfim [1] = 0;
}

/* Emulate - Controla a sequencia das operacoes de tratamento de recepacao
   e transmissao */

void emulate (void)
{
  int character=FALSE, scan_code,
      x, y;
  char entr;

  jan=salve_janela (1, 1, 80, 25, jan);
  moldura (1, 1, 80, 24, jan, 0, BLACK, WHITE);
  textbackground (BLACK);
  textattr (7);
  attrib=7;

  clrscr_asm ();
  liga_rodape ();
  inic_pegach ();
  do {
    if ((character=read_serial ()) != FALSE) {
      receive_asm (character, attrib);
      continue;
    }
    if ((scan_code=bioskey (1)) != 0) {
      entr=getch();
      inic_pegach ();
      send_sequence (entr, scan_code);
    }
  } while (scan_code!=ALTX);

  getch ();

  jan=feche_janela (jan);
}
